library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

ENTITY UART IS
PORT (
CLOCK_50: IN std_logic;
SW: IN std_logic_vector (9 downto 0);
KEY: IN std_logic_vector (3 downto 0);
LEDR: OUT std_logic_vector(9 downto 0);
LEDG: OUT std_logic_vector (7 downto 0);
UART_TX: OUT std_logic;
UART_RX: IN std_logic 
);
END UART;

ARCHITECTURE MAIN OF UART IS 
SIGNAL TX_DATA: std_logic_vector (7 downto 0);
SIGNAL TX_START: std_logic:='0';
SIGNAL TX_BUSY: std_logic;

COMPONENT TX
PORT (
CLK: IN std_logic;
START: IN std_logic;
BUSY: OUT std_logic;
DATA: IN std_logic_vector (7 downto 0);
TX_LINE: OUT std_logic);
END COMPONENT TX;

BEGIN
C1: TX PORT MAP (CLOCK_50,TX_START,TX_BUSY,TX_DATA,UART_TX);

PROCESS (CLOCK_50)
BEGIN
IF (CLOCK_50 'EVENT AND CLOCK_50='1') THEN
IF (KEY(0)='0' AND TX_BUSY='0') THEN
TX_DATA <= SW (7 downto 0);
TX_START <='1';
LEDG <=TX_DATA;
ELSE
TX_START<='0';
END IF;
END IF;
END PROCESS;
END MAIN;
